(
SynthDef(\markovS1, {
	arg out, freq, tsize, amp = 0.8, clip=1, gate = 1, fadeTime = 1;
	var snd, env;

    env = EnvGen.kr(Env([0, 1, 0], [fadeTime, fadeTime], \sin, 1), gate, doneAction: Done.freeSelf);
	snd = MarkovSynth.ar(SinOsc.ar(freq), 1, 0, tsize);
	snd = snd.clip2(clip);
	snd = snd * env * amp;

	Out.ar(out, snd);
}).add;

)