(
SynthDef(\stndTrigRing, {
	arg out=0, freq=1000, min=1, max=10, decay=0.1, ffreq=1000, amp=1, gate=1, fadeTime=1;
	var snd, in, env;

	in = StandardTrig.ar(min,max);
	snd = Ringz.ar(in, freq, decay);
	snd = LPF.ar(snd, ffreq);
    env = EnvGen.kr(
        Env([0, 1, 0], [fadeTime, fadeTime], \sin, 1),
        gate, doneAction: Done.freeSelf);

	snd = snd * env * amp;
	Out.ar(out,snd)
}).add;
);

(
SynthDef(\henoTrigRing, {
	arg out=0, freq=1000, min=1, max=10, decay=0.1, ffreq=1000, amp=1, gate=1, fadeTime=1;
	var snd, in, env;

	in = HenonTrig.ar(min,max);
	snd = Ringz.ar(in, freq, decay);
	snd = LPF.ar(snd, ffreq);
    env = EnvGen.kr(
        Env([0, 1, 0], [fadeTime, fadeTime], \sin, 1),
        gate, doneAction: Done.freeSelf);

	snd = snd * env * amp;
	Out.ar(out,snd)
}).add;
);

(
SynthDef(\gbmanTrigRing, {
	arg out=0, freq=1000, min=1, max=10, decay=0.1, ffreq=1000, amp=1, gate=1, fadeTime=1;
	var snd, in, env;

	in = GbmanTrig.ar(min,max);
	snd = Ringz.ar(in, freq, decay);
	snd = LPF.ar(snd, ffreq);
    env = EnvGen.kr(
        Env([0, 1, 0], [fadeTime, fadeTime], \sin, 1),
        gate, doneAction: Done.freeSelf);

	snd = snd * env * amp;
	Out.ar(out,snd)
}).add;
);

(
SynthDef(\latooTrigRing, {
	arg out=0, freq=1000, min=1, max=10, decay=0.1, ffreq=1000, amp=1, gate=1, fadeTime=1;
	var snd, in, env;

	in = LatoocarfianTrig.ar(min,max);
	snd = Ringz.ar(in, freq, decay);
	snd = LPF.ar(snd, ffreq);
    env = EnvGen.kr(
        Env([0, 1, 0], [fadeTime, fadeTime], \sin, 1),
        gate, doneAction: Done.freeSelf);

	snd = snd * env * amp;
	Out.ar(out,snd)
}).add;
);



(
SynthDef(\lorenzTrigRing, {
	arg out=0, freq=1000, min=1, max=10, decay=0.1, ffreq=1000, amp=1, gate=1, fadeTime=1;
	var snd, in, env;

	in = LorenzTrig.ar(min,max);
	snd = Ringz.ar(in, freq, decay);
	snd = LPF.ar(snd, ffreq);
    env = EnvGen.kr(
        Env([0, 1, 0], [fadeTime, fadeTime], \sin, 1),
        gate, doneAction: Done.freeSelf);

	snd = snd * env * amp;
	Out.ar(out,snd)
}).add;
);


(
SynthDef(\fhnTrigRing, {
	arg out=0, freq=1000, min=1, max=10, decay=0.1, ffreq=1000, amp=1, gate=1, fadeTime=1;
	var snd, in, env;

	in = FhnTrig.ar(min,max);
	snd = Ringz.ar(in, freq, decay);
	snd = LPF.ar(snd, ffreq);
    env = EnvGen.kr(
        Env([0, 1, 0], [fadeTime, fadeTime], \sin, 1),
        gate, doneAction: Done.freeSelf);

	snd = snd * env * amp;
	Out.ar(out,snd)
}).add;
);


